'use strict';

var _chai = require('chai');

var _chai2 = _interopRequireDefault(_chai);

var _sinonChai = require('sinon-chai');

var _sinonChai2 = _interopRequireDefault(_sinonChai);

var _binarysearch = require('../binarysearch');

var _binarysearch2 = _interopRequireDefault(_binarysearch);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_chai2.default.use(_sinonChai2.default);
var expect = _chai2.default.expect;


describe('Binary Search', function () {
    var arr = void 0;
    before(function () {
        arr = [10, 13, 15, 17];
    });
    it('eq', function () {
        var idx = _binarysearch2.default.eq(arr, 13, _index.defaultComparator);
        expect(idx).to.equal(1);

        var notfound = _binarysearch2.default.eq(arr, 9, _index.defaultComparator);
        expect(notfound).to.equal(-1);
    });

    it('lte', function () {
        var idx = _binarysearch2.default.lte(arr, 13, _index.defaultComparator);
        expect(idx).to.equal(1);

        var idxtwo = _binarysearch2.default.lte(arr, 12, _index.defaultComparator);
        expect(idxtwo).to.equal(0);

        expect(_binarysearch2.default.lte(arr, 10, _index.defaultComparator)).to.equal(0);

        var idxthree = _binarysearch2.default.lte(arr, 9, _index.defaultComparator);
        expect(idxthree).to.equal(-1);

        var idxfour = _binarysearch2.default.lte(arr, 18, _index.defaultComparator);
        expect(idxfour).to.equal(3);
    });

    it('gte', function () {
        var idx = _binarysearch2.default.gte(arr, 13, _index.defaultComparator);
        expect(idx).to.equal(1);
        var idxtwo = _binarysearch2.default.gte(arr, 12, _index.defaultComparator);
        expect(idxtwo).to.equal(1);

        var idxthree = _binarysearch2.default.gte(arr, 9, _index.defaultComparator);
        expect(idxthree).to.equal(0);

        var idxfour = _binarysearch2.default.gte(arr, 18, _index.defaultComparator);
        expect(idxfour).to.equal(4); // Note: this returns array length.
    });
});